package uoc.ows.actions;

import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts2.ServletActionContext;

import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionSupport;

import uoc.ows.bbdd.GestorNodes;
import uoc.ows.bbdd.GestorJobs;
import uoc.ows.bbdd.GestorEstats;
import uoc.ows.bbdd.GestorTransitions;
import uoc.ows.bbdd.GestorExecutions;

import uoc.ows.beans.*;
import uoc.ows.common.OWSException;
import uoc.ows.common.Constants;
import it.sauronsoftware.cron4j.Predictor;

// TODO: Auto-generated Javadoc
/**
 * Gestio d'actions navegaci web.
 *
 * @author Lluis Cozar Prez
 */
public class JobAction extends ActionSupport  {

	/** The Constant serialVersionUID. */
	private static final long serialVersionUID = -6659925652584240539L;

	/** The job list. */
	private List<Job> jobList = new ArrayList<Job>();
	
	/** The transition list. */
	private List<Transition> transitionList = new ArrayList<Transition>();
	
	/** The estat list. */
	private List<Estat> estatList = new ArrayList<Estat>();
	
	/** The predictor list. */
	private List<String> predictorList = new ArrayList<String>();
	
	/** The execution list. */
	private List<Execution> executionList = new ArrayList<Execution>();
	
	/** The job. */
	private Job job = new Job();
	
	
	
	/**
	 * List.
	 *
	 * @return the string
	 * @throws OWSException the oWS exception
	 */
	public String list() throws OWSException
	{
		jobList = new GestorJobs().getJobs();
		return SUCCESS;
	}
	
	/**
	 * To list a single user by Id.
	 *
	 * @return String
	 * @throws NumberFormatException the number format exception
	 * @throws OWSException the oWS exception
	 */
	public String launchTask() throws NumberFormatException, OWSException
	{
		HttpServletRequest request = (HttpServletRequest) ActionContext.getContext().get(ServletActionContext.HTTP_REQUEST);
		job = new GestorJobs().getJob(Integer.parseInt(request.getParameter("idjob")));
		
		if (job.getIdstatus().compareTo(Constants.PENDING)!=0 & 
			job.getIdstatus().compareTo(Constants.DESCHEDULED)!=0	) {
			job.setIdstatus(Constants.EXECUTE);
			new GestorJobs().updateJob(job);
			new GestorTransitions().insertTransition(job);
		}
		return SUCCESS;
	}
	
	/**
	 * Deschedule task.
	 *
	 * @return the string
	 * @throws NumberFormatException the number format exception
	 * @throws OWSException the oWS exception
	 */
	public String descheduleTask() throws NumberFormatException, OWSException
	{
		HttpServletRequest request = (HttpServletRequest) ActionContext.getContext().get(ServletActionContext.HTTP_REQUEST);
		job = new GestorJobs().getJob(Integer.parseInt(request.getParameter("idjob")));
		if (job.getIdstatus().compareTo(Constants.PENDING)!=0) {
			job.setIdstatus(Constants.DESCHEDULING);
			new GestorJobs().updateJob(job);
			new GestorTransitions().insertTransition(job);
		}
		return SUCCESS;
	}
	
	/**
	 * Schedule task.
	 *
	 * @return the string
	 * @throws NumberFormatException the number format exception
	 * @throws OWSException the oWS exception
	 */
	public String scheduleTask() throws NumberFormatException, OWSException
	{
		HttpServletRequest request = (HttpServletRequest) ActionContext.getContext().get(ServletActionContext.HTTP_REQUEST);
		job = new GestorJobs().getJob(Integer.parseInt(request.getParameter("idjob")));
		if (job.getIdstatus().compareTo(Constants.DESCHEDULED)==0) {
			job.setIdstatus(Constants.PENDING);
			new GestorJobs().updateJob(job);
			new GestorTransitions().insertTransition(job);
		}
		return SUCCESS;
	}
	
	/**
	 * To list a single user by Id.
	 *
	 * @return String
	 * @throws NumberFormatException the number format exception
	 * @throws OWSException the oWS exception
	 */
	public String view() throws NumberFormatException, OWSException
	{
		HttpServletRequest request = (HttpServletRequest) ActionContext.getContext().get(ServletActionContext.HTTP_REQUEST);
		job = new GestorJobs().getJob(Integer.parseInt(request.getParameter("idjob")));
		job.setNode(new GestorNodes().getNodeDNS(job.getIdnode()));
		transitionList = new GestorTransitions().getTransitions(job.getIdjob());
		return SUCCESS;
	}
	
	/**
	 * Change.
	 *
	 * @return the string
	 * @throws NumberFormatException the number format exception
	 * @throws OWSException the oWS exception
	 */
	public String change() throws NumberFormatException, OWSException
	{
		HttpServletRequest request = (HttpServletRequest) ActionContext.getContext().get(ServletActionContext.HTTP_REQUEST);
		job = new GestorJobs().getJob(Integer.parseInt(request.getParameter("idjob")));
		estatList = new GestorEstats().getEstats();
		System.out.println(request.getParameterNames());
		
		return SUCCESS;
	}
	
	/**
	 * Predictor.
	 *
	 * @return the string
	 * @throws NumberFormatException the number format exception
	 * @throws OWSException the oWS exception
	 */
	public String predictor() throws NumberFormatException, OWSException
	{
		HttpServletRequest request = (HttpServletRequest) ActionContext.getContext().get(ServletActionContext.HTTP_REQUEST);
		job = new GestorJobs().getJob(Integer.parseInt(request.getParameter("idjob")));
		job.setNode(new GestorNodes().getNodeDNS(job.getIdnode()));
		Predictor p = new Predictor(job.getPattern());
		for (int i = 0; i < 5; i++) {
			predictorList.add(p.nextMatchingDate().toString());
			
		}
		return SUCCESS;
	}
	
	/**
	 * Execucions.
	 *
	 * @return the string
	 * @throws NumberFormatException the number format exception
	 * @throws OWSException the oWS exception
	 */
	public String execucions() throws NumberFormatException, OWSException
	{
		HttpServletRequest request = (HttpServletRequest) ActionContext.getContext().get(ServletActionContext.HTTP_REQUEST);
		job = new GestorJobs().getJob(Integer.parseInt(request.getParameter("idjob")));
		job.setNode(new GestorNodes().getNodeDNS(job.getIdnode()));
		executionList = new GestorExecutions().getExecutions(job.getIdjob());
		return SUCCESS;
	}

	/**
	 * Sysprint.
	 *
	 * @return the string
	 * @throws NumberFormatException the number format exception
	 * @throws OWSException the oWS exception
	 */
	public String sysprint() throws NumberFormatException, OWSException
	{
		HttpServletRequest request = (HttpServletRequest) ActionContext.getContext().get(ServletActionContext.HTTP_REQUEST);
		job = new GestorJobs().getJob(Integer.parseInt(request.getParameter("idjob")));
		job.setNode(new GestorNodes().getNodeDNS(job.getIdnode()));
		executionList = new GestorExecutions().getExecution(Integer.parseInt(request.getParameter("idjob")),
				request.getParameter("timestamp"));
		return SUCCESS;
	}
	
	/**
	 * Gets the execution list.
	 *
	 * @return the execution list
	 */
	public List<Execution> getExecutionList() {
		return executionList;
	}

	/**
	 * Sets the execution list.
	 *
	 * @param executionList the new execution list
	 */
	public void setExecutionList(List<Execution> executionList) {
		this.executionList = executionList;
	}

	/**
	 * Gets the predictor list.
	 *
	 * @return the predictor list
	 */
	public List<String> getPredictorList() {
		return predictorList;
	}

	/**
	 * Sets the predictor list.
	 *
	 * @param predictorList the new predictor list
	 */
	public void setPredictorList(List<String> predictorList) {
		this.predictorList = predictorList;
	}

	/**
	 * Gets the estat list.
	 *
	 * @return the estat list
	 */
	public List<Estat> getEstatList() {
		return estatList;
	}

	/**
	 * Sets the estat list.
	 *
	 * @param estatList the new estat list
	 */
	public void setEstatList(List<Estat> estatList) {
		this.estatList = estatList;
	}

	/**
	 * Gets the job list.
	 *
	 * @return the job list
	 */
	public List<Job> getJobList() {
		return jobList;
	}

	/**
	 * Sets the job list.
	 *
	 * @param jobList the new job list
	 */
	public void setJobList(List<Job> jobList) {
		this.jobList = jobList;
	}
	
	/**
	 * Gets the transition list.
	 *
	 * @return the transition list
	 */
	public List<Transition> getTransitionList() {
		return transitionList;
	}

	/**
	 * Sets the transition list.
	 *
	 * @param transitionList the new transition list
	 */
	public void setTransitionList(List<Transition> transitionList) {
		this.transitionList = transitionList;
	}
	
	/**
	 * Gets the job.
	 *
	 * @return the job
	 */
	public Job getJob() {
		return job;
	}

	/**
	 * Sets the job.
	 *
	 * @param job the new job
	 */
	public void setJob(Job job) {
		this.job = job;
	}

}
