package uoc.ows.bbdd;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import uoc.ows.beans.Estat;
import uoc.ows.common.OWSException;

// TODO: Auto-generated Javadoc
/**
 * Gestio d'acces a la taula de estats.
 *
 * @author Lluis Cozar Prez
 */
public class GestorEstats extends GestorDiscConnexio {

	/**
	 * Instantiates a new gestor estats.
	 *
	 * @throws OWSException the oWS exception
	 */
	public GestorEstats() throws OWSException {
		super.conectarBD();
	}
	
	/**
	 * Instantiates a new gestor estats.
	 *
	 * @param con the con
	 * @throws OWSException the oWS exception
	 */
	public GestorEstats(Connection con) throws OWSException {
		conexion = con;
	}
	
		
	/**
	 * * web **.
	 *
	 * @return the estats
	 * @throws OWSException the oWS exception
	 */ 
	
	public List<Estat> getEstats() throws OWSException{
		List<Estat> estats = new ArrayList<Estat>();
		
		ResultSet rs;
		PreparedStatement pst;
		
		if (conexion==null) conexion = getConexion();
		
		String sql = "SELECT idestado, description FROM estado WHERE isFinal = true";
                   
		
		try{
			pst = crearPreparedStatement(sql);
			pst.clearParameters();
			rs = pst.executeQuery();
			 
			while(rs.next()){
				Estat estat = new Estat();
				estat.setIdestat(rs.getString("idestado"));
				estat.setDescription(rs.getString("description")); 
				estats.add(estat);
			}
			pst.close();
			rs.close();
			
		}catch(SQLException sqle){
			System.out.println(sqle.getMessage());
            throw new OWSException(OWSException.ERR_SQL);
		}catch (Exception e) {
            System.out.println(e.getMessage());
            throw new OWSException(OWSException.ERR_DESC_EXEC);
        }
				
		return estats;
	}

}
