package uoc.ows.beans;

import java.util.Date;
import java.io.Serializable;
import org.apache.commons.lang3.builder.ToStringBuilder;

/**
 * Job
 * Bean que representa un registre de la taula de jobs.
 *
 * @author LLuis Cozar Prez
 */
public class Job implements Serializable {

	
	private static final long serialVersionUID = 1L;
	
	private int idjob;
	private int idnode;
	private String node;
	private String idstatus;
	private String offsetjob;
	private String executionCmd;
	private String executionEnv;
	private String executionParm;
	private int lastRC;
	private int numberofTransitions;
	private int numberofExecutions;
	private Date insertTimestamp;
	private Date lastUpdateTimestamp;
	private String pattern;

	public Job() {
		
	}
	public Job(int idjob, int idnode, String idstatus, String offsetjob, String executionCmd, 
			String executionEnv, String executionParm, int lastRC, int numberofTransitions, int numberofExecutions, 
			Date insertTimestamp, Date lastUpdateTimstamp, String pattern) {
		
		this.idjob = idjob;
		this.idnode = idnode;
		this.idstatus = idstatus;
		this.offsetjob = offsetjob;
		this.executionCmd = executionCmd;
		this.executionEnv = executionEnv;
		this.executionParm = executionParm;
		this.lastRC = lastRC;
		this.numberofExecutions = numberofExecutions;
		this.numberofTransitions = numberofTransitions;
		this.insertTimestamp = insertTimestamp;
		this.lastUpdateTimestamp = lastUpdateTimstamp;
		this.pattern = pattern;
		
	}
	
	public int getIdjob() {
		return idjob;
	}
	
	public void setIdjob(int idjob) {
		this.idjob = idjob;
	}

	public int getIdnode() {
		return idnode;
	}
	
	public void setIdnode(int idnode) {
		this.idnode = idnode;
	}
	
	public String getIdstatus() {
		return idstatus;
	}

	public void setIdstatus(String idstatus) {
		this.idstatus = idstatus;
	}
	
	public String getOffsetjob() {
		return offsetjob;
	}

	public void setOffsetjob(String offsetjob) {
		this.offsetjob = offsetjob;
	}

	public String getExecutionCmd() {
		return executionCmd;
	}

	public void setExecutionCmd(String executionCmd) {
		this.executionCmd = executionCmd;
	}

	public String getExecutionEnv() {
		return executionEnv;
	}

	public void setExecutionEnv(String executionEnv) {
		this.executionEnv = executionEnv;
	}

	public String getExecutionParm() {
		return executionParm;
	}

	public void setExecutionParm(String executionParm) {
		this.executionParm = executionParm;
	}
	
	public int getLastRC() {
		return lastRC;
	}
	
	public void setLastRC(int lastRC) {
		this.lastRC = lastRC;
	}
	
	public int getNumberofExecutions() {
		return numberofExecutions;
	}
	
	public void setNumberofExecutions(int numberofExecutions) {
		this.numberofExecutions = numberofExecutions;
	}
	
	public int getNumberofTransitions() {
		return numberofTransitions;
	}
	
	public void setNumberofTransitions(int numberofTransitions) {
		this.numberofTransitions = numberofTransitions;
	}
	
	public Date getInsertTimestamp() {
		return insertTimestamp;
	}
	
	public void setInsertTimestamp(Date insertTimestamp) {
		this.insertTimestamp = insertTimestamp;
	}
	
	public Date getLastUpdateTimestamp() {
		return lastUpdateTimestamp;
	}
	
	public void setLastUpdateTimestamp(Date lastUpdateTimestamp) {
		this.lastUpdateTimestamp = lastUpdateTimestamp;
	}
	
	public String getPattern() {
		return pattern;
	}

	public void setPattern(String pattern) {
		this.pattern = pattern;
	}
	
	public String toString() {
		   return ToStringBuilder.reflectionToString(this);
		 }
	
	public String getNode() {
		return node;
	}
	public void setNode(String node) {
		this.node = node;
	}
	
}
