-- MySQL dump 10.13  Distrib 5.5.28, for osx10.6 (i386)
--
-- Host: localhost    Database: ows_scheduler
-- ------------------------------------------------------
-- Server version	5.5.28


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

DROP DATABASE IF EXISTS `ows_scheduler`;
CREATE DATABASE `ows_scheduler` /*!40100 DEFAULT CHARACTER SET latin1 */;
USE `ows_scheduler`;
--
-- Table structure for table `estado`
--

DROP TABLE IF EXISTS `estado`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estado` (
  `idestado` varchar(45) NOT NULL,
  `description` varchar(45) DEFAULT NULL,
  `isFinal` tinyint(4) DEFAULT NULL,
  PRIMARY KEY (`idestado`),
  KEY `idstatus_idx` (`idestado`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estado`
--

LOCK TABLES `estado` WRITE;
/*!40000 ALTER TABLE `estado` DISABLE KEYS */;
INSERT INTO `estado` VALUES ('DESCHEDULED',NULL,1),('DESCHEDULING',NULL,0),('EXECUTE NOW',NULL,1),('EXECUTION FAILED',NULL,1),('EXECUTION SUCCESFUL',NULL,1),('PENDING',NULL,1),('RESCHEDULED',NULL,1),('RESCHEDULING',NULL,0),('SCHEDULED',NULL,1),('SUBMIT FAILED',NULL,1),('SUBMIT IN PROGRESS',NULL,0),('SUBMIT REQUEST',NULL,0);
/*!40000 ALTER TABLE `estado` ENABLE KEYS */;
UNLOCK TABLES;

DROP TABLE IF EXISTS `nodes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `nodes` (
  `idnode` int(11) NOT NULL DEFAULT '0',
  `description` varchar(45) COLLATE latin1_spanish_ci DEFAULT NULL,
  `ipadress` varchar(45) COLLATE latin1_spanish_ci DEFAULT NULL,
  `isAvailable` tinyint(1) DEFAULT NULL,
  `qname` varchar(45) COLLATE latin1_spanish_ci DEFAULT NULL,
  PRIMARY KEY (`idnode`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `nodes`
--

LOCK TABLES `nodes` WRITE;
/*!40000 ALTER TABLE `nodes` DISABLE KEYS */;
INSERT INTO `nodes` VALUES (1,'mac','localhost',NULL,NULL),(2,'windows 7','192.168.2.14',NULL,NULL),(3,'linux (ubuntu)','192.168.2.13',NULL,NULL),(4,'imac','192.168.2.3',NULL,NULL);
/*!40000 ALTER TABLE `nodes` ENABLE KEYS */;
UNLOCK TABLES;

DROP TABLE IF EXISTS `jobs`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `jobs` (
  `idjob` int(11) NOT NULL AUTO_INCREMENT,
  `idnode` int(11) NOT NULL,
  `idestado` varchar(45) NOT NULL,
  `offsetjob` varchar(512) DEFAULT NULL,
  `executionCmd` varchar(255) DEFAULT NULL,
  `executionEnv` varchar(100) DEFAULT NULL,
  `executionParm` varchar(100) DEFAULT NULL,
  `lastRC` int(11) DEFAULT NULL,
  `numberofTransitions` int(11) DEFAULT '0',
  `numberofExecutions` int(11) DEFAULT '0',
  `insertTimestamp` datetime DEFAULT NULL,
  `lastUpdateTimestamp` datetime DEFAULT NULL,
  `pattern` varchar(100) DEFAULT NULL,
  PRIMARY KEY (`idjob`),
  KEY `idnode_idx` (`idnode`),
  KEY `idestado_idx` (`idestado`),
  CONSTRAINT `idestado` FOREIGN KEY (`idestado`) REFERENCES `estado` (`idestado`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `idnode` FOREIGN KEY (`idnode`) REFERENCES `nodes` (`idnode`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB AUTO_INCREMENT=9 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `executions`
--

DROP TABLE IF EXISTS `executions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `executions` (
  `timestamp` datetime NOT NULL,
  `idjob` int(11) NOT NULL,
  `offsetjob` varchar(512) NOT NULL,
  `position` int(11) NOT NULL,
  `line` varchar(2000) DEFAULT NULL,
  PRIMARY KEY (`timestamp`,`idjob`,`offsetjob`,`position`),
  KEY `idjob_exec_idx` (`idjob`),
  CONSTRAINT `idjob_exec` FOREIGN KEY (`idjob`) REFERENCES `jobs` (`idjob`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;


DROP TABLE IF EXISTS `transacciones`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `transacciones` (
  `autoinc` int(11) NOT NULL AUTO_INCREMENT,
  `timestamp` datetime NOT NULL,
  `idjob` int(11) NOT NULL,
  `offsetjob` varchar(512) NOT NULL,
  `idestado` varchar(45) NOT NULL DEFAULT '',
  PRIMARY KEY (`autoinc`,`timestamp`,`idjob`,`offsetjob`,`idestado`),
  KEY `idjob_idx` (`idjob`),
  KEY `idstatus_idx` (`idestado`),
  CONSTRAINT `idjob` FOREIGN KEY (`idjob`) REFERENCES `jobs` (`idjob`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `idstatus` FOREIGN KEY (`idestado`) REFERENCES `estado` (`idestado`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB AUTO_INCREMENT=173 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;
delimiter $$

-- Dump completed on 2012-12-08 15:35:53
