package uoc.ows.bbdd;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import uoc.ows.beans.Job;
import uoc.ows.common.OWSException;

// TODO: Auto-generated Javadoc
/**
 * Gestio d'acces a la taula de transicions.
 *
 * @author Lluis Cozar Prez
 */

public class GestorTransitions extends GestorDiscConnexio {

	/**
	 * Instantiates a new gestor transitions.
	 *
	 * @throws OWSException the oWS exception
	 */
	public GestorTransitions() throws OWSException {
		
	}
	
	/**
	 * Instantiates a new gestor transitions.
	 *
	 * @param con the con
	 * @throws OWSException the oWS exception
	 */
	public GestorTransitions(Connection con) throws OWSException {
		conexion = con;
	}
	
	/**
	 * Insert transition.
	 *
	 * @param job the job
	 * @throws OWSException the oWS exception
	 */
	public void insertTransition(Job job) throws OWSException {

		if (conexion == null)
			conexion = getConexion();

		try {
			conexion.setAutoCommit(false);
			
			String sql = "INSERT transacciones (idjob, idestado, timestamp, offsetjob) VALUES (?, ?, now(), ?) ";
			PreparedStatement pst = conexion.prepareStatement(sql);

			pst.clearParameters();
			pst.setInt(1, job.getIdjob());
			pst.setString(2, job.getIdstatus());
			pst.setString(3,  job.getOffsetjob());
		
			try {
				pst.executeUpdate();
			} catch (SQLException sqle) {
				System.out.println(sqle.getMessage());
				conexion.rollback();
				throw new OWSException(OWSException.ERR_SQL);
			}
			
			conexion.commit();
			conexion.setAutoCommit(true);
			pst.close();
			
		} catch (SQLException sqle) {
			System.out.println(sqle.getMessage());
			throw new OWSException(OWSException.ERR_SQL);
		} catch (Exception e) {
			System.out.println(e.getMessage());
			throw new OWSException(OWSException.ERR_DESC_EXEC);
		}
		
	}
	

}
