package uoc.ows.beans;

import java.util.Date;
import java.io.Serializable;
import org.apache.commons.lang3.builder.ToStringBuilder;

/**
 * Job
 * Bean que representa un registre de la taula de jobs.
 *
 * @author LLuis Cozar Prez
 */

public class Job implements Serializable {

	
	/** The Constant serialVersionUID. */
	private static final long serialVersionUID = 1L;
	
	/** The idjob. */
	private int idjob;
	
	/** The idnode. */
	private int idnode;
	private String node;
	private String idstatus;
	
	/** The offsetjob. */
	private String offsetjob;
	
	/** The execution cmd. */
	private String executionCmd;
	
	/** The execution env. */
	private String executionEnv;
	
	/** The execution parm. */
	private String executionParm;
	
	/** The last rc. */
	private int lastRC;
	
	/** The numberof transitions. */
	private int numberofTransitions;
	
	/** The numberof executions. */
	private int numberofExecutions;
	
	/** The insert timestamp. */
	private Date insertTimestamp;
	
	/** The last update timestamp. */
	private Date lastUpdateTimestamp;
	
	/** The pattern. */
	private String pattern;

	/**
	 * Instantiates a new job.
	 */
	public Job() {
		
	}
	
	/**
	 * Instantiates a new job.
	 *
	 * @param idjob  
	 * @param idnode  
	 * @param idstatus  
	 * @param offsetjob  
	 * @param executionCmd 
	 * @param executionEnv 
	 * @param executionParm 
	 * @param lastRC 
	 * @param numberofTransitions 
	 * @param numberofExecutions 
	 * @param insertTimestamp 
	 * @param lastUpdateTimstamp 
	 * @param pattern 
	 */
	public Job(int idjob, int idnode, String idstatus, String offsetjob, String executionCmd, 
			String executionEnv, String executionParm, int lastRC, int numberofTransitions, int numberofExecutions, 
			Date insertTimestamp, Date lastUpdateTimstamp, String pattern) {
		
		this.idjob = idjob;
		this.idnode = idnode;
		this.idstatus = idstatus;
		this.offsetjob = offsetjob;
		this.executionCmd = executionCmd;
		this.executionEnv = executionEnv;
		this.executionParm = executionParm;
		this.lastRC = lastRC;
		this.numberofExecutions = numberofExecutions;
		this.numberofTransitions = numberofTransitions;
		this.insertTimestamp = insertTimestamp;
		this.lastUpdateTimestamp = lastUpdateTimstamp;
		this.pattern = pattern;
		
	}
	
	/**
	 * Gets the idjob.
	 *
	 * @return the idjob
	 */
	public int getIdjob() {
		return idjob;
	}
	
	/**
	 * Sets the idjob.
	 *
	 * @param idjob the new idjob
	 */
	public void setIdjob(int idjob) {
		this.idjob = idjob;
	}

	/**
	 * Gets the idnode.
	 *
	 * @return the idnode
	 */
	public int getIdnode() {
		return idnode;
	}
	
	/**
	 * Sets the idnode.
	 *
	 * @param idnode the new idnode
	 */
	public void setIdnode(int idnode) {
		this.idnode = idnode;
	}
	
	/**
	 * Gets the idstatus.
	 *
	 * @return the idstatus
	 */
	public String getIdstatus() {
		return idstatus;
	}

	/**
	 * Sets the idstatus.
	 *
	 * @param idstatus the new idstatus
	 */
	public void setIdstatus(String idstatus) {
		this.idstatus = idstatus;
	}
	
	/**
	 * Gets the offsetjob.
	 *
	 * @return the offsetjob
	 */
	public String getOffsetjob() {
		return offsetjob;
	}

	/**
	 * Sets the offsetjob.
	 *
	 * @param offsetjob the new offsetjob
	 */
	public void setOffsetjob(String offsetjob) {
		this.offsetjob = offsetjob;
	}

	/**
	 * Gets the execution cmd.
	 *
	 * @return the execution cmd
	 */
	public String getExecutionCmd() {
		return executionCmd;
	}

	/**
	 * Sets the execution cmd.
	 *
	 * @param executionCmd the new execution cmd
	 */
	public void setExecutionCmd(String executionCmd) {
		this.executionCmd = executionCmd;
	}

	/**
	 * Gets the execution env.
	 *
	 * @return the execution env
	 */
	public String getExecutionEnv() {
		return executionEnv;
	}

	/**
	 * Sets the execution env.
	 *
	 * @param executionEnv the new execution env
	 */
	public void setExecutionEnv(String executionEnv) {
		this.executionEnv = executionEnv;
	}

	/**
	 * Gets the execution parm.
	 *
	 * @return the execution parm
	 */
	public String getExecutionParm() {
		return executionParm;
	}

	/**
	 * Sets the execution parm.
	 *
	 * @param executionParm the new execution parm
	 */
	public void setExecutionParm(String executionParm) {
		this.executionParm = executionParm;
	}
	
	/**
	 * Gets the last rc.
	 *
	 * @return the last rc
	 */
	public int getLastRC() {
		return lastRC;
	}
	
	/**
	 * Sets the last rc.
	 *
	 * @param lastRC the new last rc
	 */
	public void setLastRC(int lastRC) {
		this.lastRC = lastRC;
	}
	
	/**
	 * Gets the numberof executions.
	 *
	 * @return the numberof executions
	 */
	public int getNumberofExecutions() {
		return numberofExecutions;
	}
	
	/**
	 * Sets the numberof executions.
	 *
	 * @param numberofExecutions the new numberof executions
	 */
	public void setNumberofExecutions(int numberofExecutions) {
		this.numberofExecutions = numberofExecutions;
	}
	
	/**
	 * Gets the numberof transitions.
	 *
	 * @return the numberof transitions
	 */
	public int getNumberofTransitions() {
		return numberofTransitions;
	}
	
	/**
	 * Sets the numberof transitions.
	 *
	 * @param numberofTransitions the new numberof transitions
	 */
	public void setNumberofTransitions(int numberofTransitions) {
		this.numberofTransitions = numberofTransitions;
	}
	
	/**
	 * Gets the insert timestamp.
	 *
	 * @return the insert timestamp
	 */
	public Date getInsertTimestamp() {
		return insertTimestamp;
	}
	
	/**
	 * Sets the insert timestamp.
	 *
	 * @param insertTimestamp the new insert timestamp
	 */
	public void setInsertTimestamp(Date insertTimestamp) {
		this.insertTimestamp = insertTimestamp;
	}
	
	/**
	 * Gets the last update timestamp.
	 *
	 * @return the last update timestamp
	 */
	public Date getLastUpdateTimestamp() {
		return lastUpdateTimestamp;
	}
	
	/**
	 * Sets the last update timestamp.
	 *
	 * @param lastUpdateTimestamp the new last update timestamp
	 */
	public void setLastUpdateTimestamp(Date lastUpdateTimestamp) {
		this.lastUpdateTimestamp = lastUpdateTimestamp;
	}
	
	/**
	 * Gets the pattern.
	 *
	 * @return the pattern
	 */
	public String getPattern() {
		return pattern;
	}

	/**
	 * Sets the pattern.
	 *
	 * @param pattern the new pattern
	 */
	public void setPattern(String pattern) {
		this.pattern = pattern;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		   return ToStringBuilder.reflectionToString(this);
		 }
	
	public String getNode() {
		return node;
	}
	public void setNode(String node) {
		this.node = node;
	}
	
}
