package uoc.ows.common;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.logging.Formatter;
import java.util.logging.LogRecord;

/**
 * CustomRecordFormatter
 * Reformateig del log que apareix per consola
 *
 * @author LLuis Cozar Prez
 */

public class CustomRecordFormatter extends Formatter {
	@Override
	public String format(final LogRecord record) {

		Date date = new Date(record.getMillis());
		DateFormat formatter = new SimpleDateFormat("HH:mm:ss:SSS");
		String dateFormatted = formatter.format(date);
		
		return dateFormatted + " " + record.getLevel() + " "
				+ record.getSourceClassName() + " "
				+ record.getSourceMethodName() + " >> " + record.getMessage()
				+ "\n";

	}
}