package uoc.ows.common;

import java.io.*;

import javax.jms.JMSException;

import uoc.ows.beans.MessageExecutionMQ;
import uoc.ows.nodeclient.MessageExecutionSender;

/**
 * StreamGobbler
 * Lectura i gesti de sortida BufferedReader.
 *
 * @author LLuis Cozar Prez
 */

public class StreamGobbler extends Thread
{
    
    /** The is. */
    InputStream is;
    
    /** The type. */
    String type;
    
    /** The os. */
    OutputStream os;
    
    /** The msg execution mq. */
    MessageExecutionMQ msgExecutionMQ;
    
    /**
     * Instantiates a new stream gobbler.
     *
     * @param is 
     * @param type 
     * @param msgExecutionMQ 
     */
    public StreamGobbler(InputStream is, String type, MessageExecutionMQ msgExecutionMQ)
    {
        this(is, type, null, msgExecutionMQ);
    }
    
    /**
     * Instantiates a new stream gobbler.
     *
     * @param is 
     * @param type 
     * @param redirect 
     * @param msgExecutionMQ 
     */
    public StreamGobbler(InputStream is, String type, OutputStream redirect, MessageExecutionMQ msgExecutionMQ)
    {
        this.is = is;
        this.type = type;
        this.os = redirect;
        this.msgExecutionMQ = msgExecutionMQ;
    }
    
    public void run()
    {
        try
        {
            PrintWriter pw = null;
            if (os != null)
                pw = new PrintWriter(os);
                
            InputStreamReader isr = new InputStreamReader(is);
            BufferedReader br = new BufferedReader(isr);
            String line=null;
            int contador = 0;
            while ( (line = br.readLine()) != null)
            {
                if (pw != null)
                    pw.println(line);
                    
                contador++;
                MessageExecutionMQ msgExecutionMQ = new MessageExecutionMQ();
                msgExecutionMQ.setIdjob(this.msgExecutionMQ.getIdjob());
                msgExecutionMQ.setOffsetjob(this.msgExecutionMQ.getOffsetjob());
                msgExecutionMQ.setPosition(contador);
                msgExecutionMQ.setLine(line);
                msgExecutionMQ.setQname(this.msgExecutionMQ.getQname());
            	msgExecutionMQ.setQnameReply(this.msgExecutionMQ.getQnameReply());
            	msgExecutionMQ.setReceiverNode(this.msgExecutionMQ.getReceiverNode());
            	msgExecutionMQ.setSenderNode(this.msgExecutionMQ.getSenderNode());
            	msgExecutionMQ.setTimestamp(this.msgExecutionMQ.getTimestamp());
                
                try {	
        	    	final MessageExecutionSender messageSender = new MessageExecutionSender();
        		    messageSender.sendMessages(msgExecutionMQ, "RECEIVE");
        	    } catch (JMSException e) { 
        	    	
        	    }
            }
            if (pw != null)
                pw.flush();
        } catch (IOException ioe)
            {
            ioe.printStackTrace();  
            }
    }
}