package uoc.ows.server;

import it.sauronsoftware.cron4j.Task;
import it.sauronsoftware.cron4j.TaskExecutionContext;
import uoc.ows.server.MessageSender;
import javax.jms.*;
import uoc.ows.beans.Job;
import uoc.ows.beans.MessageSimpleMQ;


/**
 * ActiveMQTask
 * Representa la tasca que execute el scheduler un cop arriba l'hora d'execuci del treball
 * No deixa de ser un bean/missatge mq encuat cap al node de la xarxa 
 *
 * @author Lluis Cozar Prez
 */

public class ActiveMqTask extends Task {

	Job job; 
	MessageSimpleMQ msgMQ; 
	
	
	public ActiveMqTask(){
		super();
	}
	
	public ActiveMqTask(Job job) {
		super();
		this.job = job; 
	}
	
	public Job getJob() {
		return job;
	}

	public void setJob(Job job) {
		this.job = job;
	}
	
	public MessageSimpleMQ getMessageMQ() {
		return msgMQ;
	}

	public void setMessagesMQ(MessageSimpleMQ msgMQ) {
		this.msgMQ = msgMQ;
	}

	public boolean canBePaused() {
		return true;
	}

	public boolean canBeStopped() {
		return true;
	}

	public boolean supportsCompletenessTracking() {
		return true;
	}

	public boolean supportsStatusTracking() {
		return true;
	}

	public void execute(TaskExecutionContext context) throws RuntimeException {
		
	    try {	
	    	final MessageSender messageSender = new MessageSender();
	    	this.msgMQ.setTimestamp(new java.util.Date());
		    messageSender.sendMessages(this.msgMQ, "SEND");
	    } catch (JMSException e) { 
	    	
	    }
	        
	}

}
